import RSVP from 'rsvp';
import Base, { ModalArgs } from './base';
import { EbmmConfirmPayload, EbmmPromiseFactory } from '../../services/modals-manager';
export default class ProgressModal<T> extends Base {
    /**
     * Number of fulfilled promises
     *
     * @property done
     * @type number
     * @default 0
     */
    protected done: number;
    /**
     * Number of promises
     *
     * This value is set initially and must be used instead of `promises.length`,
     * because `promises`-array is changed while execution
     *
     * @property promisesCount
     * @type number
     * @default 0
     */
    protected promisesCount: number;
    /**
     * @property canceled
     * @type boolean
     * @default false
     */
    protected canceled: boolean;
    protected get settled(): boolean;
    protected errors: import("@ember/array/-private/native-array").default<any>;
    protected results: import("@ember/array/-private/native-array").default<any>;
    protected get promises(): EbmmPromiseFactory[];
    get progress(): number;
    constructor(owner: unknown, args: ModalArgs);
    cancel(): void;
    initProgress(): void;
    next(promiseFactory: EbmmPromiseFactory): RSVP.Promise<T> | void;
    _next(result?: EbmmConfirmPayload): void;
    _complete(): void;
}
